diff -uNp -r xmlto-0.0.18-orig/format/docbook/awt xmlto-0.0.18/format/docbook/awt
--- xmlto-0.0.18-orig/format/docbook/awt	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/docbook/awt	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,17 @@
+case "$1" in
+stylesheet)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to XSL-FO"
+  fi
+  echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
+  ;;
+post-process)
+  EXT=$(basename $0) 
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to ${EXT}"
+  fi
+  # Get the FO format script to do the rest
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/fo xmlto-0.0.18/format/docbook/fo
--- xmlto-0.0.18-orig/format/docbook/fo	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/docbook/fo	2005-10-25 12:56:36.000000000 -0500
@@ -7,6 +7,6 @@ stylesheet)
   echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
   ;;
 post-process)
-  cp "$XSLT_PROCESSED" "$OUTPUT_DIR/$(basename "${XSLT_PROCESSED%.*}").fo"
+  cp "$XSLT_PROCESSED" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).fo"
   ;;
 esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/html-nochunks xmlto-0.0.18/format/docbook/html-nochunks
--- xmlto-0.0.18-orig/format/docbook/html-nochunks	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/docbook/html-nochunks	2005-10-25 12:56:36.000000000 -0500
@@ -7,6 +7,6 @@ stylesheet)
   echo "http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl"
   ;;
 post-process)
-  cp "$XSLT_PROCESSED" "$OUTPUT_DIR/$(basename "${XSLT_PROCESSED%.*}").html"
+  cp "$XSLT_PROCESSED" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).html"
   ;;
 esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/mif xmlto-0.0.18/format/docbook/mif
--- xmlto-0.0.18-orig/format/docbook/mif	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/docbook/mif	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,17 @@
+case "$1" in
+stylesheet)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to XSL-FO"
+  fi
+  echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
+  ;;
+post-process)
+  EXT=$(basename $0) 
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to ${EXT}"
+  fi
+  # Get the FO format script to do the rest
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/pcl xmlto-0.0.18/format/docbook/pcl
--- xmlto-0.0.18-orig/format/docbook/pcl	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/docbook/pcl	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,17 @@
+case "$1" in
+stylesheet)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to XSL-FO"
+  fi
+  echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
+  ;;
+post-process)
+  EXT=$(basename $0) 
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to ${EXT}"
+  fi
+  # Get the FO format script to do the rest
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/pdf xmlto-0.0.18/format/docbook/pdf
--- xmlto-0.0.18-orig/format/docbook/pdf	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/docbook/pdf	2005-10-25 12:56:36.000000000 -0500
@@ -7,7 +7,11 @@ stylesheet)
   echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
   ;;
 post-process)
+  EXT=$(basename $0) 
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to ${EXT}"
+  fi
   # Get the FO format script to do the rest
-  sh "$(dirname "$0")/../fo/$(basename "$0")" "$1"
-  ;;
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
 esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/ps xmlto-0.0.18/format/docbook/ps
--- xmlto-0.0.18-orig/format/docbook/ps	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/docbook/ps	2005-10-25 12:56:36.000000000 -0500
@@ -7,7 +7,11 @@ stylesheet)
   echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
   ;;
 post-process)
+  EXT=$(basename $0) 
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to ${EXT}"
+  fi
   # Get the FO format script to do the rest
-  sh "$(dirname "$0")/../fo/$(basename "$0")" "$1"
-  ;;
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
 esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/svg xmlto-0.0.18/format/docbook/svg
--- xmlto-0.0.18-orig/format/docbook/svg	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/docbook/svg	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,17 @@
+case "$1" in
+stylesheet)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to XSL-FO"
+  fi
+  echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
+  ;;
+post-process)
+  EXT=$(basename $0) 
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Convert to ${EXT}"
+  fi
+  # Get the FO format script to do the rest
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/docbook/txt xmlto-0.0.18/format/docbook/txt
--- xmlto-0.0.18-orig/format/docbook/txt	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/docbook/txt	2005-10-25 12:56:36.000000000 -0500
@@ -1,34 +1,17 @@
-if [ -x /usr/bin/w3m ]
-then
-  CONVERT=/usr/bin/w3m
-  ARGS="-T text/html -dump"
-elif [ -x /usr/bin/lynx ]
-then
-  CONVERT=/usr/bin/lynx
-  ARGS="-force_html -dump -nolist -width=72"
-elif [ -x /usr/bin/links ]
-then
-  CONVERT=/usr/bin/links
-  ARGS="-dump"
-else
-  echo >&2 "No way to convert HTML to text found."
-  exit 1
-fi
-
 case "$1" in
 stylesheet)
   if [ "$VERBOSE" -ge 1 ]
   then
-    echo >&2 "Convert to HTML (no chunks)"
+    echo >&2 "Convert to XSL-FO"
   fi
-  echo "http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl"
+  echo "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl"
   ;;
 post-process)
+  EXT=$(basename $0) 
   if [ "$VERBOSE" -ge 1 ]
   then
-    echo >&2 "Convert HTML to ASCII"
+    echo >&2 "Convert to ${EXT}"
   fi
-  ${CONVERT} ${ARGS} ${POSTARGS} ${XSLT_PROCESSED} > \
-   "$OUTPUT_DIR/$(basename "${XSLT_PROCESSED%.*}").txt"
-  ;;
+  # Get the FO format script to do the rest
+  sh "$(dirname "$0")/../fo/${EXT}" "$1"
 esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/awt xmlto-0.0.18/format/fo/awt
--- xmlto-0.0.18-orig/format/fo/awt	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/fo/awt	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,11 @@
+EXT=$(basename $0) 
+case "$1" in
+stylesheet)
+  ;;
+post-process)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Rendering XSL-FO to screen"
+  fi
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/dvi xmlto-0.0.18/format/fo/dvi
--- xmlto-0.0.18-orig/format/fo/dvi	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/fo/dvi	2005-10-25 12:56:36.000000000 -0500
@@ -29,6 +29,6 @@ post-process)
       [ "$VERBOSE" -ge 3 ] && cat $OUT
     fi
   fi
-  cp -- *.dvi "$OUTPUT_DIR/$(basename "${XSLT_PROCESSED%.*}").dvi"
+  cp -- *.dvi "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).dvi"
   ;;
 esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/mif xmlto-0.0.18/format/fo/mif
--- xmlto-0.0.18-orig/format/fo/mif	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/fo/mif	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,11 @@
+EXT=$(basename $0) 
+case "$1" in
+stylesheet)
+  ;;
+post-process)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Post-process XSL-FO to PDF"
+  fi
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).${EXT}"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/pcl xmlto-0.0.18/format/fo/pcl
--- xmlto-0.0.18-orig/format/fo/pcl	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/fo/pcl	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,11 @@
+EXT=$(basename $0) 
+case "$1" in
+stylesheet)
+  ;;
+post-process)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Post-process XSL-FO to PDF"
+  fi
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).${EXT}"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/pdf xmlto-0.0.18/format/fo/pdf
--- xmlto-0.0.18-orig/format/fo/pdf	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/fo/pdf	2005-10-25 12:56:36.000000000 -0500
@@ -1,3 +1,4 @@
+EXT=$(basename $0) 
 case "$1" in
 stylesheet)
   ;;
@@ -6,29 +7,5 @@ post-process)
   then
     echo >&2 "Post-process XSL-FO to PDF"
   fi
-  # Work around stupid tetex bug with '_' in filenames
-  # Also work around stupid tetex limitation with long lines (bug #101055)
-  sed -e "s,/>,\n/>,g" "$XSLT_PROCESSED" >tmp.fo
-  OUT=output
-  TEXINPUTS="$(dirname "$INPUT_FILE")::$SEARCHPATH"
-  export TEXINPUTS
-  pdfxmltex ${POSTARGS} tmp.fo >$OUT </dev/null || { cat $OUT; exit 1; }
-  [ "$VERBOSE" -ge 2 ] && echo >&2 "First pass complete"
-  # If there were undefined references we need to re-run pdfxmltex.
-  if egrep '^LaTeX Warning: There were undefined references.$' $OUT \
-						>/dev/null 2>&1 \
-  || egrep '^LaTeX Warning: Label.s. may have changed\.' $OUT \
-						>/dev/null 2>&1
-  then
-    pdfxmltex ${POSTARGS} tmp.fo >$OUT </dev/null
-    [ "$VERBOSE" -ge 2 ] && echo >&2 "Second pass complete"
-    pdfxmltex ${POSTARGS} tmp.fo >$OUT </dev/null
-    if [ "$VERBOSE" -ge 2 ]
-    then
-      echo >&2 "Third pass complete"
-      [ "$VERBOSE" -ge 3 ] && cat $OUT
-    fi
-  fi
-  cp -- *.pdf "$OUTPUT_DIR/$(basename "${XSLT_PROCESSED%.*}").pdf"
-  ;;
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).${EXT}"
 esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/ps xmlto-0.0.18/format/fo/ps
--- xmlto-0.0.18-orig/format/fo/ps	2005-10-25 12:55:51.000000000 -0500
+++ xmlto-0.0.18/format/fo/ps	2005-10-25 12:56:36.000000000 -0500
@@ -1,38 +1,11 @@
+EXT=$(basename $0) 
 case "$1" in
 stylesheet)
   ;;
 post-process)
   if [ "$VERBOSE" -ge 1 ]
   then
-    echo >&2 "Post-process XSL-FO to DVI"
+    echo >&2 "Post-process XSL-FO to PDF"
   fi
-  # Work around stupid tetex bug with '_' in filenames
-  # Also work around stupid tetex limitation with long lines (bug #101055)
-  sed -e "s,/>,\n/>,g" "$XSLT_PROCESSED" >tmp.fo
-  OUT=output
-  TEXINPUTS="$(dirname "$INPUT_FILE")::$SEARCHPATH"
-  export TEXINPUTS
-  xmltex ${POSTARGS} tmp.fo >$OUT </dev/null || { cat $OUT; exit 1; }
-  [ "$VERBOSE" -ge 2 ] && echo >&2 "First pass complete"
-  # If there were undefined references we need to re-run xmltex.
-  if egrep '^LaTeX Warning: There were undefined references.$' $OUT \
-						>/dev/null 2>&1 \
-  || egrep '^LaTeX Warning: Label.s. may have changed\.' $OUT \
-						>/dev/null 2>&1
-  then
-    xmltex ${POSTARGS} tmp.fo >$OUT </dev/null
-    [ "$VERBOSE" -ge 2 ] && echo >&2 "Second pass complete"
-    xmltex ${POSTARGS} tmp.fo >$OUT </dev/null
-    if [ "$VERBOSE" -ge 2 ]
-    then
-      echo >&2 "Third pass complete"
-      [ "$VERBOSE" -ge 3 ] && cat $OUT
-    fi
-  fi
-  if [ "$VERBOSE" -ge 1 ]
-  then
-    echo >&2 "Post-process DVI to PS"
-  fi
-  dvips -R -q ${POSTPOSTARGS} -o "$OUTPUT_DIR/$(basename "${XSLT_PROCESSED%.*}").ps" *.dvi
-  ;;
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).${EXT}"
 esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/svg xmlto-0.0.18/format/fo/svg
--- xmlto-0.0.18-orig/format/fo/svg	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/fo/svg	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,11 @@
+EXT=$(basename $0) 
+case "$1" in
+stylesheet)
+  ;;
+post-process)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Post-process XSL-FO to PDF"
+  fi
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).${EXT}"
+esac
diff -uNp -r xmlto-0.0.18-orig/format/fo/txt xmlto-0.0.18/format/fo/txt
--- xmlto-0.0.18-orig/format/fo/txt	1969-12-31 18:00:00.000000000 -0600
+++ xmlto-0.0.18/format/fo/txt	2005-10-25 12:56:36.000000000 -0500
@@ -0,0 +1,11 @@
+EXT=$(basename $0) 
+case "$1" in
+stylesheet)
+  ;;
+post-process)
+  if [ "$VERBOSE" -ge 1 ]
+  then
+    echo >&2 "Post-process XSL-FO to PDF"
+  fi
+  fop ${POSTARGS} -fo "${XSLT_PROCESSED}" -"${EXT}" "$OUTPUT_DIR/$(basename ${XSLT_PROCESSED%.*}).${EXT}"
+esac