From edbb3f2ae499fa5961e1d157f2d3c1adc956b0db Mon Sep 17 00:00:00 2001
From: giardia <giardia@fedoraproject.org>
Date: Wed, 16 May 2017 19:51:07 +0200
Subject: [PATCH] New IP space for staging

---
 master/stg.phx2.fedoraproject.org | 262 ++++++++++++++++++++------------------
 1 file changed, 135 insertions(+), 127 deletions(-)

diff --git a/master/stg.phx2.fedoraproject.org b/master/stg.phx2.fedoraproject.org
index 736b5a6..e950b4d 100644
--- a/master/stg.phx2.fedoraproject.org
+++ b/master/stg.phx2.fedoraproject.org
@@ -4,7 +4,7 @@ $TTL 3600
 ; Make SURE to update the serial # when changes are made. Format is
 ; YYYYMMDDNN (NN is just a counter to handle multiple changes in one
 ; day). 
-                2017051008 ; Serial
+                2017051600 ; Serial
                 3600       ; Refresh
                 600        ; Retry
                 1000000    ; Expire
@@ -12,140 +12,140 @@ $TTL 3600
 @               IN      NS      ns03.phx2.fedoraproject.org.
 @               IN      NS      ns04.phx2.fedoraproject.org.
 
-dhcp00		    IN      A	    10.5.128.10
-dhcp01		    IN      A	    10.5.128.11
-dhcp02		    IN      A	    10.5.128.12
-dhcp03		    IN      A	    10.5.128.13
-dhcp04		    IN      A	    10.5.128.14
-dhcp05		    IN      A	    10.5.128.15
-dhcp06		    IN      A	    10.5.128.16
-dhcp07		    IN      A	    10.5.128.17
-dhcp08		    IN      A	    10.5.128.18
-dhcp09		    IN      A	    10.5.128.19
-dhcp10		    IN      A	    10.5.128.20
+dhcp00              IN      A       10.5.128.10
+dhcp01              IN      A       10.5.128.11
+dhcp02              IN      A       10.5.128.12
+dhcp03              IN      A       10.5.128.13
+dhcp04              IN      A       10.5.128.14
+dhcp05              IN      A       10.5.128.15
+dhcp06              IN      A       10.5.128.16
+dhcp07              IN      A       10.5.128.17
+dhcp08              IN      A       10.5.128.18
+dhcp09              IN      A       10.5.128.19
+dhcp10              IN      A       10.5.128.20
 
-ask01               IN      A       10.5.126.80
-autocloud-backend01 IN      A       10.5.126.125
-autocloud-backend02 IN      A       10.5.126.126
-autocloud-web01     IN      A       10.5.126.3
-autocloud-web02     IN      A       10.5.126.89
-autosign01          IN      A	    10.5.126.139
-badges-backend01    IN      A       10.5.126.68
-badges-web01        IN      A       10.5.126.69
-basset01            IN	    A	    10.5.126.138
-blockerbugs01       IN      A       10.5.126.65
-bodhi-backend01     IN      A       10.5.126.90
+ask01               IN      A       10.5.128.79
+autocloud-backend01 IN      A       10.5.128.125
+autocloud-backend02 IN      A       10.5.128.126
+autocloud-web01     IN      A       10.5.128.117
+autocloud-web02     IN      A       10.5.128.118
+autosign01	    IN	    A	    10.5.128.22
+badges-backend01    IN      A       10.5.128.100
+badges-web01        IN      A       10.5.128.101
+basset01	    IN	    A	    10.5.128.194
+blockerbugs01       IN      A       10.5.128.53
+bodhi-backend01     IN      A       10.5.128.90
 bodhi-backend01-nfs IN      A       10.5.127.65
-bodhi01             IN      A       10.5.126.166
-bodhi02             IN      A       10.5.126.169
-bugyou01            IN      A       10.5.126.130
-bugzilla2fedmsg01   IN      A       10.5.126.84
-buildvm-01          IN      A       10.5.126.14
-buildvm-02          IN      A       10.5.126.223
-buildvm-03          IN      A       10.5.126.224
-buildvm-04          IN      A       10.5.126.225
-buildvm-05          IN      A       10.5.126.226
-busgateway01        IN      A       10.5.126.62
-composer            IN      A       10.5.126.6
-darkserver-backend01 IN     A       10.5.126.124
-darkserver-web01    IN      A       10.5.126.92
-darkserver-web02    IN      A       10.5.126.120
-datagrepper01       IN      A       10.5.126.67
-datagrepper02       IN      A       10.5.126.74
-db03                IN      A       10.5.126.113
-db-fas01    	    IN	    A       10.5.126.78
-db-koji             IN      A       10.5.126.190
-db-koji01           IN      A       10.5.126.188
-db-koji02           IN      A       10.5.126.189
-db01                IN      A       10.5.126.204
-db02                IN      A       10.5.126.85
-docker-candidate-registry01 IN	A   10.5.126.218
-docker-registry01   IN      A       10.5.126.217
-docker-registry02   IN      A       10.5.126.237
-elections01    	    IN      A	    10.5.126.105
-elections02    	    IN	    A	    10.5.126.106
-faf01               IN      A       10.5.126.199
-fas-all             IN      A       10.5.126.86
-fas01               IN      A       10.5.126.86
-fas3-01             IN      A       10.5.126.28
-fedimg01            IN      A       10.5.126.9
-fedocal01           IN      A       10.5.126.66
-gallery01           IN      A       10.5.126.70
-github2fedmsg01     IN      A       10.5.126.167
-hotness01           IN      A       10.5.126.4
-ipa01    	    IN	    A	    10.5.126.8
-ipsilon01           IN      A       10.5.126.35
-kerneltest01        IN      A       10.5.126.77
-koji01              IN      A       10.5.126.87
-koschei-backend01   IN      A       10.5.126.227
-koschei-web01       IN      A       10.5.126.228
-loopabull01         IN      A       10.5.126.229
-mailman01           IN      A       10.5.126.58
-mbs-backend01       IN      A       10.5.126.211
-mbs-frontend01      IN      A       10.5.126.207
-mbs-frontend02      IN      A       10.5.126.208
-mdapi01             IN      A       10.5.126.206
-memcached01         IN      A       10.5.126.210
-mirrorlist-phx2     IN      A       10.5.126.178
-mm-backend01        IN      A       10.5.126.180
+bodhi01             IN      A       10.5.128.110
+bodhi02             IN      A       10.5.128.165
+bugyou01            IN      A       10.5.128.129
+bugzilla2fedmsg01   IN      A       10.5.128.249
+buildvm-01          IN      A       10.5.128.14
+buildvm-02          IN      A       10.5.128.223
+buildvm-03          IN      A       10.5.128.224
+buildvm-04          IN      A       10.5.128.225
+buildvm-05          IN      A       10.5.128.226
+busgateway01        IN      A       10.5.128.64
+composer            IN      A       10.5.128.6
+darkserver-backend01 IN     A       10.5.128.124
+darkserver-web01    IN      A       10.5.128.92
+darkserver-web02    IN      A       10.5.128.120
+datagrepper01       IN      A       10.5.128.18
+datagrepper02       IN      A       10.5.128.19
+db03                IN      A       10.5.128.112
+db-fas01	    IN	    A	    10.5.128.99
+db-koji             IN      A       10.5.128.190
+db-koji01           IN      A       10.5.128.188
+db-koji02           IN      A       10.5.128.189
+db01                IN      A       10.5.128.71
+db02                IN      A       10.5.128.72
+docker-candidate-registry01 IN  A   10.5.128.218
+docker-registry01   IN      A       10.5.128.217
+docker-registry02   IN      A       10.5.128.237
+elections01	    IN	    A	    10.5.128.107
+elections02	    IN	    A	    10.5.128.108
+faf01               IN      A       10.5.128.199
+fas-all             IN      A       10.5.128.30
+fas01               IN      A       10.5.128.25
+fas3-01             IN      A       10.5.128.28
+fedimg01            IN      A       10.5.128.10
+fedocal01           IN      A       10.5.128.55
+gallery01           IN      A       10.5.128.70
+github2fedmsg01     IN      A       10.5.128.195
+hotness01           IN      A       10.5.128.5
+ipa01	            IN	    A	    10.5.128.162
+ipsilon01           IN      A       10.5.128.46
+kerneltest01        IN      A       10.5.128.136
+koji01              IN      A       10.5.128.87
+koschei-backend01   IN      A       10.5.128.227
+koschei-web01       IN      A       10.5.128.140
+loopabull01         IN      A       10.5.128.229
+mailman01           IN      A       10.5.128.36
+mbs-backend01       IN      A       10.5.128.236
+mbs-frontend01      IN      A       10.5.128.234
+mbs-frontend02      IN      A       10.5.128.235
+mdapi01             IN      A       10.5.128.206
+memcached01         IN      A       10.5.128.176
+mirrorlist-phx2     IN      A       10.5.128.50
+mm-backend01        IN      A       10.5.128.183
 mm-backend01-nfs    IN      A       10.5.127.26
-mm-crawler01        IN      A       10.5.126.181
-mm-frontend01       IN      A       10.5.126.179
-modernpaste01       IN      A       10.5.126.221
-noc01               IN      A       10.5.126.2
-notifs-backend01    IN      A       10.5.126.75
-notifs-web01        IN      A       10.5.126.48
-notifs-web02        IN      A       10.5.126.109
-nuancier01          IN      A       10.5.126.202
-nuancier02          IN      A       10.5.126.203
-osbs-control01      IN      A       10.5.126.200
-osbs-master01       IN	    A       10.5.126.216
-osbs-node01         IN	    A	    10.5.126.219
-osbs-node02         IN	    A	    10.5.126.213
-osbs01              IN      A       10.5.126.114
-packages03          IN      A       10.5.126.42
-paste01             IN      A       10.5.126.61
-pdc-backend01       IN      A       10.5.126.135
-pdc-backend02       IN      A       10.5.126.240
-pdc-backend03       IN      A       10.5.126.243
-pdc-web01           IN      A       10.5.126.133
-pgbdr               IN      A       10.5.126.193
-pgbdr01             IN      A       10.5.126.191
-pgbdr02             IN      A       10.5.126.192
-pkgdb01             IN      A       10.5.126.20
-pkgs01              IN      A       10.5.126.83
+mm-crawler01        IN      A       10.5.128.184
+mm-frontend01       IN      A       10.5.128.182
+modernpaste01       IN      A       10.5.128.230
+noc01               IN      A       10.5.128.41
+notifs-backend01    IN      A       10.5.128.168
+notifs-web01        IN      A       10.5.128.103
+notifs-web02        IN      A       10.5.128.119
+nuancier01          IN      A       10.5.128.231
+nuancier02          IN      A       10.5.128.232
+osbs-control01      IN      A       10.5.128.200
+osbs-master01       IN	    A       10.5.128.216
+osbs-node01         IN	    A	    10.5.128.219
+osbs-node02         IN	    A	    10.5.128.213
+osbs01              IN      A       10.5.128.114
+packages03          IN      A       10.5.128.43
+paste01             IN	    A	    10.5.128.59
+pdc-backend01       IN      A       10.5.128.134
+pdc-backend02       IN      A       10.5.128.239
+pdc-backend03       IN      A       10.5.128.242
+pdc-web01           IN      A       10.5.128.131
+pgbdr               IN      A       10.5.128.193
+pgbdr01             IN      A       10.5.128.191
+pgbdr02             IN      A       10.5.128.192
+pkgdb01             IN      A       10.5.128.15
+pkgs01              IN      A       10.5.128.83
 pkgs01-nfs          IN      A       10.5.127.124
-pkgs02              IN      A       10.5.126.201
+pkgs02              IN      A       10.5.128.201
 pkgs02-nfs          IN      A       10.5.127.224
-proxy01             IN      A       10.5.126.88
-retrace01           IN      A       10.5.126.198
-sign-bridge01       IN	    A       10.5.126.127
-sign-vault01        IN	    A       10.5.126.128
-statscache-backend01 IN     A       10.5.126.82
-statscache-web01    IN      A       10.5.126.33
-statscache-web02    IN      A       10.5.126.34
-summershum01        IN      A       10.5.126.209
-sundries01          IN      A       10.5.126.24
-tagger01            IN      A       10.5.126.220
-value01             IN      A       10.5.126.91
-wiki01              IN      A       10.5.126.60
+proxy01             IN      A       10.5.128.52
+retrace01           IN      A       10.5.128.198
+sign-bridge01       IN	    A	    10.5.128.127
+sign-vault01        IN	    A	    10.5.128.128
+statscache-backend01 IN     A       10.5.128.81
+statscache-web01    IN      A       10.5.128.31
+statscache-web02    IN      A       10.5.128.32
+summershum01        IN      A       10.5.128.205
+sundries01          IN      A       10.5.128.38
+tagger01            IN      A       10.5.128.212
+value01             IN      A       10.5.128.49
+wiki01              IN      A       10.5.128.63
 wiki01-nfs          IN      A       10.5.127.42
-zanata2fedmsg01     IN      A       10.5.126.197
+zanata2fedmsg01     IN      A       10.5.128.196
 
 
-db-fedocal    	    IN      CNAME   pgbdr    
-db-tahrir    	    IN      CNAME   pgbdr    
-db-mbs              IN      CNAME   db01    
-db-darkserver       IN      CNAME   db02    
-db-datanommer       IN      CNAME   pgbdr    
-db-elections        IN	    CNAME   pgbdr    
-db-fas    	    IN	    CNAME   db-fas01    
-db-ykksm    	    IN	    CNAME   db-fas01    
-db-ykval    	    IN	    CNAME   db-fas01    
-db-community        IN	    CNAME   db02    
-db-mirrormanager    IN	    CNAME   db01    
-db-pkgdb    	    IN	    CNAME   db01    
-db-raffle    	    IN	    CNAME   db02    
+db-fedocal          IN      CNAME   pgbdr
+db-tahrir           IN      CNAME   pgbdr
+db-mbs              IN      CNAME   db01
+db-darkserver       IN      CNAME   db02
+db-datanommer       IN      CNAME   pgbdr
+db-elections        IN      CNAME   pgbdr
+db-fas              IN      CNAME   db-fas01
+db-ykksm            IN      CNAME   db-fas01
+db-ykval            IN      CNAME   db-fas01
+db-community        IN      CNAME   db02
+db-mirrormanager    IN      CNAME   db01
+db-pkgdb            IN      CNAME   db01
+db-raffle           IN      CNAME   db02
 ; openshift staging instance
 os-control01        IN      A       10.5.128.100
 os-master01         IN      A       10.5.128.101
@@ -161,3 +161,11 @@ os-nodes            IN      A       10.5.128.105
 
 os                  IN      CNAME   os-masters
 *.apps.os           IN      CNAME   os-nodes
+
+
+
+
+
+
+
+
-- 
2.9.4