Index: Makefile.config
===================================================================
RCS file: /cvs/pkgs/devel/kernel/Makefile.config,v
retrieving revision 1.59
diff -u -p -r1.59 Makefile.config
--- Makefile.config	12 Jul 2007 19:15:37 -0000	1.59
+++ Makefile.config	9 Aug 2007 11:12:08 -0000
@@ -13,9 +13,10 @@ CONFIGFILES	= \
 	$(CFG)-ppc.config $(CFG)-ppc-smp.config \
 	$(CFG)-ppc64.config $(CFG)-ppc64-kdump.config $(CFG)-ia64.config \
 	$(CFG)-i686-xen.config $(CFG)-x86_64-xen.config \
-	$(CFG)-ia64-xen.config
+	$(CFG)-ia64-xen.config \
+	$(CFG)-alpha.config $(CFG)-alpha-smp.config
 
-PLATFORMS	= x86 x86_64 powerpc powerpc32 powerpc64 s390x ia64 # sparc sparc64
+PLATFORMS	= x86 x86_64 powerpc powerpc32 powerpc64 s390x ia64 # alpha sparc sparc64
 TEMPFILES	= $(addprefix temp-, $(addsuffix -generic, $(PLATFORMS)))
 
 configs: $(CONFIGFILES)
@@ -63,6 +64,9 @@ temp-s390-generic: config-s390x temp-gen
 temp-ia64-generic: config-ia64-generic temp-generic
 	perl merge.pl $^ > $@
 
+temp-alpha-generic: /dev/null temp-generic
+	perl merge.pl $^ > $@
+
 temp-x86-xen-generic-tmp: config-xen-generic temp-x86-generic
 	perl merge.pl $^ > $@
 
@@ -129,6 +133,12 @@ kernel-$(VERSION)-ppc-smp.config: config
 kernel-$(VERSION)-ia64.config: config-ia64 temp-ia64-generic
 	perl merge.pl $^ ia64 > $@
 
+kernel-$(VERSION)-alpha.config: config-alpha temp-alpha-generic
+	perl merge.pl $^ alpha > $@
+
+kernel-$(VERSION)-alpha-smp.config: config-alpha-smp temp-alpha-generic
+	perl merge.pl $^ alpha > $@
+
 kernel-$(VERSION)-i686-xen.config: config-i686-PAE temp-x86-xen-generic
 	perl merge.pl $^ i386 > $@
 
Index: kernel.spec
===================================================================
RCS file: /cvs/pkgs/devel/kernel/kernel.spec,v
retrieving revision 1.54
diff -u -p -r1.54 kernel.spec
--- kernel.spec	4 Aug 2007 05:09:32 -0000	1.54
+++ kernel.spec	9 Aug 2007 11:12:09 -0000
@@ -206,8 +206,8 @@ Summary: The Linux kernel (the core of t
 
 # Overrides for generic default options
 
-# only ppc and sparc64 need separate smp kernels
-%ifnarch ppc sparc64 alphaev56
+# only ppc, sparc64 and alpha need separate smp kernels
+%ifnarch ppc sparc64 alpha alphaev56
 %define with_smp 0
 %endif
 
@@ -255,11 +255,22 @@ Summary: The Linux kernel (the core of t
 %define with_modsign 0
 %endif
 
-# sparse blows up on ppc64
+# sparse blows up on ppc64 and alpha
 %ifarch ppc64 ppc alpha
 %define usesparse 0
 %endif
 
+%ifarch alpha alphaev56
+%define with_smp 0
+%define with_pae 0
+%define with_xen 0
+%define with_kdump 0
+%define usesparse 0
+%define with_modsign 1
+%define with_debug 0
+%define with_debuginfo 0
+%endif
+
 # Per-arch tweaks
 
 %ifarch %{all_x86}
@@ -326,7 +337,7 @@ Summary: The Linux kernel (the core of t
 
 %ifarch alpha alphaev56
 %define all_arch_configs kernel-%{version}-alpha*.config
-%define image_install_path boot
+%define image_install_path vmlinux
 %define make_target vmlinux
 %define kernel_image vmlinux
 %endif
@@ -477,6 +488,9 @@ Source90: config-sparc64-generic
 Source91: config-sparc64
 Source92: config-sparc64-smp
 
+Source100: config-alpha
+Source101: config-alpha-smp
+
 %if %{using_upstream_branch}
 ### BRANCH PATCH ###
 %else
@@ -592,6 +606,10 @@ Patch800: linux-2.6-wakeups-hdaps.patch
 Patch801: linux-2.6-wakeups.patch
 Patch820: linux-2.6-compile-fixes.patch
 Patch1100: linux-2.6-elf-core-sysctl.patch
+
+Patch1101: linux-2.6.21-alpha_execshield.patch
+Patch1102: linux-2.6.21-alpha_pagesize.patch
+
 Patch1200: linux-2.6-ps3-gelic-wireless.patch
 Patch1210: linux-2.6-ps3-storage-alias.patch
 Patch1220: linux-2.6-ps3-legacy-bootloader-hack.patch
@@ -1051,7 +1069,10 @@ ApplyPatch linux-2.6-build-nonintconfig.
 %if 0
 # Roland's utrace ptrace replacement.
 # Main patch includes i386, x86_64, powerpc.
+# So we need to ifarch it out on alpha
+%ifarch alpha alphaev56
 ApplyPatch linux-2.6-utrace-tracehook.patch
+%endif
 # Additional arch work by other contributors.
 ApplyPatch linux-2.6-utrace-tracehook-ia64.patch
 ApplyPatch linux-2.6-utrace-tracehook-sparc64.patch
@@ -1117,7 +1138,10 @@ ApplyPatch linux-2.6-powerpc-generic-sus
 
 
 # Exec shield
+# Doesn't work on alpha :-(
+%ifnarch alpha alphaev56
 ApplyPatch linux-2.6-execshield.patch
+%endif
 
 #
 # GPG signed kernel modules
@@ -1232,6 +1256,10 @@ ApplyPatch linux-2.6-compile-fixes.patch
 # core dump enhancement
 ApplyPatch linux-2.6-elf-core-sysctl.patch
 
+# Alpha patches
+ApplyPatch linux-2.6.21-alpha_execshield.patch
+ApplyPatch linux-2.6.21-alpha_pagesize.patch
+
 # END OF PATCH APPLICATIONS
 
 # Any further pre-build tree manipulations happen here.
@@ -2142,6 +2170,11 @@ fi
 %endif
 
 %changelog
+* Mon Aug 06 2007 Oliver Falk <oliver@linux-kernel.at>
+- Build for alpha with alpha specific patches
+- Fix PAGE_SIZE for headers
+- no upstream report so far
+
 * Sat Aug 04 2007 Dave Jones <davej@redhat.com>
 - 2.6.23-rc2